#ifndef TIME_UTILS_H
#define TIME_UTILS_H

#include <stdint.h>  // For int64_t or int32_t
#include <stddef.h>  // for size_t
#include <string.h>  // for strcmp
#include <stdio.h>   // for snprintf


// Define time_t only if not already defined
#ifndef _TIME_T_DECLARED
typedef int64_t time_t;
#define _TIME_T_DECLARED
#endif

// Define struct tm only if not already defined
#ifndef _TM_DEFINED
#define _TM_DEFINED
struct my_tm {
    int tm_sec;   // seconds [0, 59]
    int tm_min;   // minutes [0, 59]
    int tm_hour;  // hours [0, 23]
    int tm_mday;  // day of month [1, 31]
    int tm_mon;   // months since January [0, 11]
    int tm_year;  // years since 1900
    int tm_wday;  // days since Sunday [0, 6]
    int tm_yday;  // days since Jan 1 [0, 365]
    int tm_isdst; // daylight savings flag (not used)
};
#endif // _TM_DEFINED

time_t my_mktime(const struct my_tm *t);
struct my_tm *my_localtime(const time_t *timep);
int my_strftime(char *buf, size_t max, const char *fmt, const struct my_tm *t);

#endif // TIME_UTILS_H
